《Java从小白到大牛》之第14章 异常处理(下)

字数 2207阅读 36

《Java从小白到大牛》纸质版已经上架了!!!


Java从小白到大牛书皮

释放资源

有时在try-catch语句中会占用一些非Java资源,如:打开文件、网络连接、打开数据库连接和使用数据结果集等,这些资源并非Java资源,不能通过JVM的垃圾收集器回收,需要程序员释放。为了确保这些资源能够被释放可以使用finally代码块或Java 7之后提供自动资源管理(Automatic Resource Management)技术。

finally代码块 {#finally}

try-catch语句后面还可以跟有一个finally代码块,try-catch-finally语句语法如下:

try{

//可能会生成异常语句

} catch(Throwable e1){

//处理异常e1

} catch(Throwable e2){

//处理异常e1

} catch(Throwable eN){

//处理异常eN

} finally{

//释放资源

}

无论try正常结束还是catch异常结束都会执行finally代码块,如同14-2所示。

图14-2 finally代码块流程

使用finally代码块示例代码如下:

//HelloWorld.java文件

package com.a51work6;

… …

public class HelloWorld {

public static void main(String[] args) {

Date date = readDate();

System.out.println("读取的日期 = " + date);

}

public static Date readDate() {

FileInputStream readfile = null;

InputStreamReader ir = null;

BufferedReader in = null;

try {

readfile = new FileInputStream("readme.txt");

ir = new InputStreamReader(readfile);

in = new BufferedReader(ir);

// 读取文件中的一行数据

String str = in.readLine();

if (str == null) {

return null;

}

DateFormat df = new SimpleDateFormat("yyyy-MM-dd");

Date date = df.parse(str);

return date;

} catch (FileNotFoundException e) {

System.out.println("处理FileNotFoundException...");

e.printStackTrace();

} catch (IOException e) {

System.out.println("处理IOException...");

e.printStackTrace();

} catch (ParseException e) {

System.out.println("处理ParseException...");

e.printStackTrace();

} finally { ①

try {

if (readfile != null) {

readfile.close(); ②

}

} catch (IOException e) {

e.printStackTrace();

}

try {

if (ir != null) {

ir.close(); ③

}

} catch (IOException e) {

e.printStackTrace();

}

try {

if (in != null) {

in.close(); ④

}

} catch (IOException e) {

e.printStackTrace();

}

} ⑤

return null;

}

}

上述代码第①行第⑤行是finally语句,在这里通过关闭流释放资源,FileInputStream、InputStreamReader和BufferedReader是三个输入流,它们都需要关闭,见代码第②行第④行通过流的close()关闭流,但是流的close()方法还有可以能发生IOException异常,所以这里又针对每一个close()语句还需要进行捕获处理。

注意 为了代码简洁等目的,可能有的人会将finally代码中的多个嵌套的try-catch语句合并,例如将上述代码改成如下形式,将三个有可以发生异常的close()方法放到一个try-catch。读者自己考虑一下这处理是否稳妥呢?每一个close()方法对应关闭一个资源,如果第一个close()方法关闭时发生了异常,那么后面的两个也不会关闭,因此如下的程序代码是有缺陷的。

try {

... ...

} catch (FileNotFoundException e) {

... ...

} catch (IOException e) {

... ...

} catch (ParseException e) {

... ...

} finally {

try {

if (readfile != null) {

readfile.close();

}

if (ir != null) {

ir.close();

}

if (in != null) {

in.close();

}

} catch (IOException e) {

e.printStackTrace();

}

}

自动资源管理 {#-0}

14.4.1节使用finally代码块释放资源会导致程序代码大量增加,一个finally代码块往往比正常执行的程序还要多。在Java 7之后提供自动资源管理(Automatic Resource Management)技术,可以替代finally代码块,优化代码结构,提高程序可读性。

自动资源管理是在try语句上的扩展,语法如下:

try (声明或初始化资源语句) {

//可能会生成异常语句

} catch(Throwable e1){

//处理异常e1

} catch(Throwable e2){

//处理异常e1

} catch(Throwable eN){

//处理异常eN

}

在try语句后面添加一对小括号“()”,其中是声明或初始化资源语句,可以有多条语句语句之间用分号“;”分隔。

示例代码如下:

//HelloWorld.java文件

package com.a51work6;

… …

public class HelloWorld {

public static void main(String[] args) {

Date date = readDate();

System.out.println("读取的日期 = " + date);

}

public static Date readDate() {

// 自动资源管理

try (FileInputStream readfile = new FileInputStream("readme.txt"); ①

InputStreamReader ir = new InputStreamReader(readfile); ②

BufferedReader in = new BufferedReader(ir)) { ③

// 读取文件中的一行数据

String str = in.readLine();

if (str == null) {

return null;

}

DateFormat df = new SimpleDateFormat("yyyy-MM-dd");

Date date = df.parse(str);

return date;

} catch (FileNotFoundException e) {

System.out.println("处理FileNotFoundException...");

e.printStackTrace();

} catch (IOException e) {

System.out.println("处理IOException...");

e.printStackTrace();

} catch (ParseException e) {

System.out.println("处理ParseException...");

e.printStackTrace();

}

return null;

}

}

上述代码第①行~第③行是声明或初始化三个输入流,三条语句放到在try语句后面小括号中,语句之间用分号“;”分隔,这就是自动资源管理技术了,采用了自动资源管理后不再需要finally代码块,不需要自己close这些资源,释放过程交给了JVM。

注意 所有可以自动管理的资源需要实现AutoCloseable接口,上述代码中三个输入流FileInputStream、InputStreamReader和BufferedReader从Java 7之后实现AutoCloseable接口,具体哪些资源实现AutoCloseable接口需要查询API文档。

throws与声明方法抛出异常 {#throws}

在一个方法中如果能够处理异常,则需要捕获并处理。但是本方法没有能力处理该异常,捕获它没有任何意义,则需要在方法后面声明抛出该异常,通知上层调用者该方法有可以发生异常。

方法后面声明抛出使用throws关键字,回顾一下10.3.3节成员方法语法格式如下:

class className {

[public | protected | private ] [static] [final | abstract] [native] [synchronized]

type methodName([paramList]) [throws exceptionList] {

//方法体

}

}

其中参数列表之后的[throws exceptionList]语句是声明抛出异常。方法中可能抛出的异常(除了Error和RuntimeException及其子类外)都必须通过throws语句列出,多个异常之间采用逗号(,)分隔。

注意 如果声明抛出的多个异常类之间有父子关系,可以只声明抛出父类。但如果没有父子关系情况下,最好明确声明抛出每一个异常,因为上层调用者会根据这些异常信息进行相应的处理。假如一个方法中有可能抛出IOException和ParseException两个异常,那么声明抛出IOException和ParseException呢?还是只声明抛出Exception呢?因为Exception是IOException和ParseException的父类,只声明抛出Exception从语法是允许的,但是声明抛出IOException和ParseException更好一些。

如果将14.3节示例进行修改,在readDate()方法后声明抛出异常,代码如下:

//HelloWorld.java文件

package com.a51work6;

… …

public class HelloWorld {

public static void main(String[] args) { ①

try {

Date date = readDate(); ②

System.out.println("读取的日期 = " + date);

} catch (IOException e) { ③

System.out.println("处理IOException...");

e.printStackTrace();

} catch (ParseException e) { ④

System.out.println("处理ParseException...");

e.printStackTrace();

}

}

public static Date readDate() throws IOException, ParseException { ⑤

// 自动资源管理

FileInputStream readfile = new FileInputStream("readme.txt"); ⑥

InputStreamReader ir = new InputStreamReader(readfile);

BufferedReader in = new BufferedReader(ir);

// 读取文件中的一行数据

String str = in.readLine(); ⑦

if (str == null) {

return null;

}

DateFormat df = new SimpleDateFormat("yyyy-MM-dd");

Date date = df.parse(str); ⑧

return date;

}

}

由于readDate()方法中代码第⑥、⑦、⑧行都有可能引发异常。在readDate()方法内又没有捕获处理,所有需要在代码第⑤行方法后声明抛出异常,事实上有三个异常FileNotFoundException、IOException和ParseException,由于FileNotFoundException属于IOException异常,所以只声明IOException和ParseException就可以了。

一旦readDate()方法声明抛出了异常,那么它的调用者main()方法,也会面临同样的问题:要么捕获自己处理,要么抛出给上层调用者。如果一旦发生异常main()方法也选择抛出那么程序运行就会终止。本例中main()方法是捕获异常进行处理,捕获异常过程前面已经介绍过了,这里不再赘述。

自定义异常类

有些公司为了提高代码的可重用性,自己开发了一些Java类库或框架,其中少不了自己编写了一些异常类。实现自定义异常类需要继承Exception类或其子类,如果自定义运行时异常类需继承RuntimeException类或其子类。

实现自定义异常类示例代码如下:

package com.a51work6;

public class MyException extends Exception { ①

public MyException() { ②

}

public MyException(String message) { ③

super(message);

}

}

上述代码实现了自定义异常,自定义异常类一般需要提供两个构造方法,一个是代码第②行的无参数的默认构造方法,异常描述信息是空的;另一个是代码第③行的字符串参数的构造方法,message是异常描述信息,getMessage()方法可以获得这些信息。

自定义异常就这样简单,主要是提供两个构造方法就可以了,

throw与显式抛出异常 {#throw}

Java异常相关的关键字中有两个非常相似,它们是throws和throw,其中throws关键字前面14.5节已经介绍了,throws用于方法后声明抛出异常,而throw关键字用来人工引发异常。本节之前读者接触到的异常都是由于系统生成的,当异常发生时,系统一个异常对象,并将其抛出。但也可以通过throw语句显式抛出异常,语法格式如下:

throw Throwable或其子类的实例

所有Throwable或其子类的实例都可以通过throw语句抛出。

显式抛出异常目的有很多,例如不想某些异常传给上层调用者,可以捕获之后重新显式抛出另外一种异常给调用者。

修改14.4节示例代码如下:

//HelloWorld.java文件

package com.a51work6;

… …

public class HelloWorld {

public static void main(String[] args) {

try {

Date date = readDate();

System.out.println("读取的日期 = " + date);

} catch (MyException e) {

System.out.println("处理MyException...");

e.printStackTrace();

}

}

public static Date readDate() throws MyException {

// 自动资源管理

try (FileInputStream readfile = new FileInputStream("readme.txt");

InputStreamReader ir = new InputStreamReader(readfile);

BufferedReader in = new BufferedReader(ir)) {

// 读取文件中的一行数据

String str = in.readLine();

if (str == null) {

return null;

}

DateFormat df = new SimpleDateFormat("yyyy-MM-dd");

Date date = df.parse(str);

return date;

} catch (FileNotFoundException e) { ①

throw new MyException(e.getMessage()); ②

} catch (IOException e) { ③

throw new MyException(e.getMessage()); ④

} catch (ParseException e) {

System.out.println("处理ParseException...");

e.printStackTrace();

}

return null;

}

}

如果软件设计者不希望readDate()方法中捕获的FileNotFoundException和IOException异常出现在main()方法(上层调用者)中,那么可以在捕获到FileNotFoundException和IOException异常时,通过throw语句显式抛出一个异常,见代码第②行和第④行throw new MyException(e.getMessage())语句,MyException是自定义的异常。

注意 throw显式抛出的异常与系统生成并抛出的异常,在处理方式上没有区别,就是两种方法:要么捕获自己处理,要么抛出给上层调用者。在本例中是声明抛出,所以在readDate()方法后面要声明抛出MyException异常。

本章小结

本章介绍了Java异常处理机制,其中包括Java异常类继承层次、捕获异常、释放资源、throws、throw和自定义异常类。读者需要重点掌握捕获异常处理,熟悉throws和throw的区分和用法。

配套视频

http://www.zhijieketang.com/classroom/6/courses

配套源代码

http://www.zhijieketang.com/group/5

与本书免费版对应的还有一个收费版本:

  1. 进入百度阅读电子书

  2. 进入图灵社区电子书

推荐阅读更多精彩内容